#include <stdio.h>
#include <stdlib.h>


/*******************************************Declarao de Variveis********************************************************/

/************************************************ Controlador**************************************************************/
    
unsigned long int MIR,                            //inteiro com 24 bits de 32
				  Micromemoria[1000],             //vetor com 24 bits de 32
				  MPC, BI1, BI2, BI3;             //inteiros com 10 bits de 32


/************************************************ Processador**************************************************************/

int PC, Acc, R1, R2, B1, B2, B3, RDM, RI;           //inteiros com 16 bits de 32
int          REM;									//inteiro com 12 bits de 16 de 32           
int          Mem_principal[4000];					//vetor com 4000 posies de 16 bits de 32
  
/*************************************************** Outras****************************************************************/
  
unsigned int desvio = 0x00,STOP = 0;
FILE *arq_saida=NULL;  								// ponteiro para arquivo de sada
int TESTNEG();
int TESTZERO();
/******************************************Declarao de Constantes *******************************************************/

    const int bit24_24 = 0x00000001;				//bits de 1 a 24 para variaveis com 24 bits
    const int bit23_24 = 0x00000002;
    const int bit22_24 = 0x00000004;
    const int bit21_24 = 0x00000008;
    const int bit20_24 = 0x00000010;
    const int bit19_24 = 0x00000020;         
    const int bit18_24 = 0x00000040;
    const int bit17_24 = 0x00000080;
    const int bit16_24 = 0x00000100;
    const int bit15_24 = 0x00000200;
    const int bit14_24 = 0x00000400;
    const int bit13_24 = 0x00000800;
    const int bit12_24 = 0x00001000;
    const int bit11_24 = 0x00002000;
    const int bit10_24 = 0x00004000;
    const int bit09_24 = 0x00008000;
    const int bit08_24 = 0x00010000;
    const int bit07_24 = 0x00020000;
    const int bit06_24 = 0x00040000;
    const int bit05_24 = 0x00080000;
    const int bit04_24 = 0x00100000;
    const int bit03_24 = 0x00200000;
    const int bit02_24 = 0x00400000;
    const int bit01_24 = 0x00800000;
   
    const int bit13_16 = 0x00001000;
    const int bit01_16 = 0x00008000;

/*********************************************Rotinas**********************************************************************/

int pot2(int n){
	if(n==0)return(1);
	else return(2*pot2(n-1));
}

int converte_sinal(int dado){
    int valor_sinal,i;
    
    if (dado & bit01_16){
        valor_sinal = pot2(15) *(-1);
    }
    else valor_sinal=0;
    for(i=1;i<16;i++){
        if (dado & (bit01_16>>i)){
            valor_sinal = valor_sinal + pot2(15-i);
        }
    }
    return(valor_sinal);
}

void rot_desvio(){										//OK se o bit 24 estiver habilitado
            
		printf("  Rotina de Desvio\n");
		fprintf(arq_saida,"  Rotina de Desvio\n");
        
		BI2=MIR/(0x4000);  								//desvio recebe os 10 bits mais significativos do MIR
        if (!BI2){
			STOP=1;
		}
		else{
			printf("      BI2=%d\n",BI2);
			fprintf(arq_saida,"      BI2=%d\n",BI2);
		}	
}

			
void zera_barramentos(){
			BI1=0;
			BI2=0;
			BI3=0; 
			B1=0;
			B2=0;
			B3=0;
}

void fase1(){
            printf("fase1\n");
			fprintf(arq_saida,"fase1\n");
            
            if ((MIR & bit01_24) && !(MIR & bit24_24)){    						//se bit 1 esta habilitado
                    B1=PC;
					printf("    SC 1\n");
					fprintf(arq_saida,"    SC 1\n");
                    printf("      B1=%d\n",B1);
					fprintf(arq_saida,"      B1=%d\n",B1);
            }

			if ((MIR & bit02_24) && !(MIR & bit24_24)){    						//se bit 2 esta habilitado
                    B1=Acc;
					printf("    SC 2\n");
					fprintf(arq_saida,"    SC 2\n");
                    printf("      B1=%d\n",B1);
					fprintf(arq_saida,"      B1=%d\n",B1);
            }

            if ((MIR & bit03_24) && !(MIR & bit24_24)){							//se bit 3 esta habilitado
                    B1=converte_sinal(R1);
					printf("    SC 3\n");
					fprintf(arq_saida,"    SC 3\n");
                    printf("      B1=%d\n",B1);
					fprintf(arq_saida,"      B1=%d\n",B1);
            }

			if ((MIR & bit04_24) && !(MIR & bit24_24)){    						//se bit 4 esta habilitado
                    B2=converte_sinal(R2);
					printf("    SC 4\n");
					fprintf(arq_saida,"    SC 4\n");
                    printf("      B2=%d\n",B2);
					fprintf(arq_saida,"      B2=%d\n",B2);
            }

  			if ((MIR & bit05_24) && !(MIR & bit24_24)){							//se bit 5 esta habilitado
                    B2=1;
					printf("    SC 5\n");
					fprintf(arq_saida,"    SC 5\n");
                    printf("      B2=%d\n",B2);
					fprintf(arq_saida,"      B2=%d\n",B2);
                    
            }

  			if ((MIR & bit06_24) && !(MIR & bit24_24)){    						//se bit 6 esta habilitado
                    B2= converte_sinal(RI % bit12_24);  										/*apenas os 12 bits menos signific. (mod) */
                    printf("    SC 6\n");										/*- campo endereo da instruo*/
					fprintf(arq_saida,"    SC 6\n");
                    printf("      B2=%d\n",B2);
					fprintf(arq_saida,"      B2=%d\n",B2);
            }

 			if ((MIR & bit07_24) && !(MIR & bit24_24)){    						//se bit 7 esta habilitado
                    B2=converte_sinal(RDM);
					printf("    SC 7\n");
					fprintf(arq_saida,"    SC 7\n");
                    printf("      B2=%d\n",B2);
					fprintf(arq_saida,"      B2=%d\n",B2);                            
            }

			if( (!(MIR & bit08_24) & !(MIR & bit09_24)) && !(MIR & bit24_24) ){	//se bit 8 e 9 estao desabilitados
					B3=B1+B2;
					printf("    Soma_UAL\n");
					fprintf(arq_saida,"    Soma_UAL\n");
                    printf("      B3=%d\n",B3);
					fprintf(arq_saida,"      B3=%d\n",B3);
			}
			else{
				if ((MIR & bit08_24) && !(MIR & bit24_24)){    					//se bit 8 esta habilitado
					B3=B1-B2;
					printf("    SC 8\n");
					fprintf(arq_saida,"    SC8\n");
                    printf("      B3=%d\n",B3);
					fprintf(arq_saida,"      B3=%d\n",B3);
				}
				else{															//se bit 9 esta habilitado
					if (!(MIR & bit24_24)){
						B3=2*(B1+B2);
						printf("    SC 9\n");
						fprintf(arq_saida,"    SC9\n");
						printf("      B3=%d\n",B3);
						fprintf(arq_saida,"      B3=%d\n",B3);
					}
				}
			}
}


void fase2(){
            printf("fase2\n");
			fprintf(arq_saida,"fase2\n");
              
            if ((MIR & bit10_24) && !(MIR & bit24_24)){								//se bit 10 esta habilitado
                    PC=B3;
					printf("    SC 10\n");
					fprintf(arq_saida,"    SC 10\n");
                    printf("      PC=%d\n",PC);
					fprintf(arq_saida,"      PC=%d\n",PC);
            }

			if ((MIR & bit11_24) && !(MIR & bit24_24)){								//se bit 11 esta habilitado
                    Acc=B3;
					printf("    SC 11\n");
					fprintf(arq_saida,"    SC 11\n");
                    printf("      Acc=%d\n",Acc);
					fprintf(arq_saida,"      Acc=%d\n",Acc);
            }

			if ((MIR & bit12_24) && !(MIR & bit24_24)){								//se bit 12 esta habilitado
                    R1=B3;
					printf("    SC 12\n");
					fprintf(arq_saida,"    SC 12\n");
                    printf("      R1=%d\n",R1);
					fprintf(arq_saida,"      R1=%d\n",R1);
            }

			if ((MIR & bit13_24) && !(MIR & bit24_24)){								//se bit 13 esta habilitado
                    R2=B3;
					printf("    SC 13\n");
					fprintf(arq_saida,"    SC 13\n");
                    printf("      R2=%d\n",R2);
					fprintf(arq_saida,"      R2=%d\n",R2);
            }

			if ((MIR & bit14_24) && !(MIR & bit24_24)){								//se bit 14 esta habilitado
                    RDM=B3;
					printf("    SC 14\n");
					fprintf(arq_saida,"    SC 14\n");
                    printf("      RDM=%d\n",RDM);
					fprintf(arq_saida,"      RDM=%d\n",RDM);
            }

			if ((MIR & bit15_24) && !(MIR & bit24_24)){								//se bit 15 esta habilitado
                    REM=B3;
					printf("    SC 15\n");
					fprintf(arq_saida,"    SC 15\n");
                    printf("      REM=%d\n",REM);
					fprintf(arq_saida,"      REM=%d\n",REM);
            }
}


void fase3(){
            printf("fase3\n");
			fprintf(arq_saida,"fase3\n");
              
            //printf("Mem_principal[%d]=%d REM=\n",REM,Mem_principal[REM]);
            
			if ((MIR & bit16_24) && !(MIR & bit24_24)){								//se bit 16 esta habilitado
                    RDM=Mem_principal[REM];
					printf("    SC 16\n");
					fprintf(arq_saida,"    SC 16\n");
                    printf("      RDM=$%x\n",RDM);
					fprintf(arq_saida,"      RDM=$%x\n",RDM);
            }

			if ((MIR & bit17_24) && !(MIR & bit24_24)){								//se bit 17 esta habilitado
					Mem_principal[REM]= RDM & 0xFFFF;
					printf("    SC 17\n");
					fprintf(arq_saida,"    SC 17\n");
                    printf("      Mem_principal[%d]=$%x\n",REM,Mem_principal[REM]);
					fprintf(arq_saida,"      Mem_principal[%d]=$%x\n",REM,Mem_principal[REM]);
            }

			if ((MIR & bit18_24) && !(MIR & bit24_24)){								//se bit 18 esta habilitado
                    RI=RDM;
					printf("    SC 18\n");
					fprintf(arq_saida,"    SC 18\n");
                    printf("      RI=$%x\n",RI);
					fprintf(arq_saida,"      RI=$%x\n",RI);
            }
}

void fase4(){
            printf("fase4\n");
			fprintf(arq_saida,"fase4\n");
            
            if ((MIR & bit19_24) && !(MIR & bit24_24)){								//se bit 19 esta habilitado
                    BI1=1;
					printf("    SC 19\n");
					fprintf(arq_saida,"    SC 19\n");
                    printf("      BI1=%d\n",BI1);
					fprintf(arq_saida,"      BI1=%d\n",BI1);
            }

			if ((MIR & bit20_24) && !(MIR & bit24_24)){								//se bit 20 esta habilitado
                    BI1=TESTZERO();
					printf("    SC 20\n");
					fprintf(arq_saida,"    SC 20\n");
                    printf("      BI1=%d\n",BI1);
					fprintf(arq_saida,"      BI1=%d\n",BI1);
            }
            
			if ((MIR & bit21_24) && !(MIR & bit24_24)){								//se bit 21 esta habilitado
                    BI1=TESTNEG();
					printf("    SC 21\n");
					fprintf(arq_saida,"    SC 21\n");
                    printf("      BI1=%d\n",BI1);
					fprintf(arq_saida,"      BI1=%d\n",BI1);
            }
            
			if ((MIR & bit22_24) && !(MIR & bit24_24)){								//se bit 22 esta habilitado
                    BI1 = (RI/bit13_16);											//BI1= 4BITS MAIS SIG. DE RI
                    printf("    SC 22\n");
					fprintf(arq_saida,"    SC 22\n");
                    printf("      BI1=%d\n",BI1);
					fprintf(arq_saida,"      BI1=%d\n",BI1);
            }

            if ((MIR & bit23_24) && !(MIR & bit24_24)){								//se bit 23 esta habilitado
                    BI2=MPC;
					printf("    SC 23\n");
					fprintf(arq_saida,"    SC 23\n");
					printf("      BI2=%d\n",BI2);
					fprintf(arq_saida,"      BI2=%d\n",BI2);
					BI3=BI1+BI2;
					printf("      BI3=%d\n",BI3);
					fprintf(arq_saida,"      BI3=%d\n",BI3);
			}
			
			if (MIR & bit24_24){													//se bit 24 esta habilitado
					printf("    SC 24\n");
					fprintf(arq_saida,"    SC 24\n");
					rot_desvio();
					BI3=BI1+BI2;
					printf("      BI3=%d\n",BI3);
					fprintf(arq_saida,"      BI3=%d\n",BI3);
            }
}

void fase5(){
       printf("fase5\n");
	   fprintf(arq_saida,"fase5\n");
       
	   MPC=BI3;
	   printf("      MPC=%d\n",MPC);
	   fprintf(arq_saida,"      MPC=%d\n",MPC);
       MIR=Micromemoria[MPC];
       printf("      MIR=$%x\n",MIR);
	   fprintf(arq_saida,"      MIR=$%x\n",MIR);
	   zera_barramentos();	       
}

int TESTNEG(){
    if(Acc<0)return(1);
    else return(2);
}    

int TESTZERO(){
	if(Acc==0)return(1);
    else return(2);
}    

void inicia_MPC_MIR(){
	MPC=0;
	MIR=Micromemoria[MPC];
}

void converte_memprincipal(int indice,char buffer1[18]){
     int valor=0;
     int b;
     
     for(b=15;b>=0;b--){
         if (buffer1[b]=='1'){
              valor+=pot2((15-b));
         }     
     }
     Mem_principal[indice]=valor;   
	 printf("Mem_principal[%d]=$%x\n",indice,Mem_principal[indice]);
}

void insere_programa_usuario(){
	 int end=100;
	 char *nomep,nome[10];
     FILE *arq;  // ponteiro para arquivo

     while (end != 0){
           printf("\n\nDigite o nome do arquivo da memoria principal e ENTER:\n\n");
           scanf("%s",&nome);
                      
           nomep=(char*)malloc(sizeof(nome));
           nomep=nome;
           
           arq = fopen(nomep, "r");
           
           if (arq  == NULL) {
                printf("Erro ao ler arquivo.\n\n");
           }
		   else{
                 char buffer[18],STOP[18]="0001000000000000";
                 int n;                 
                 
                 printf("\n\nDigite o endereco (em decimal) de gravacao da memoria principal.\n");
                 printf("      (zero grava e inicia a simulacao):");
                 scanf("%d",&end);
                 printf("\n\n");
                 n=end;
                 
                 while( fgets(buffer,sizeof(buffer),arq) != NULL && buffer != STOP ){
                        converte_memprincipal(n,buffer);				// Mem_principal[n]=buffer 
                        n++;
                 }
           
           fclose(arq);
           getchar();			//espera enter
       
           }      
     }     
}

void insere_micromemoria_default(){         
	Micromemoria[0]= 0x00800322;	//SC 1,15,16,19,23		BUSCA INSTRUO
	Micromemoria[1]= 0x00884046;	//SC 1,5,10,18,22,23	BUSCA INSTRUO
	Micromemoria[2]= 0x00030001;	//SC 7,8,24				PULA PARA 12	LOAD
	Micromemoria[3]= 0x00038001;	//SC 7,8,9,24			PULA PARA 14	STORE
	Micromemoria[4]= 0x00040001;	//SC 6,24				PULA PARA 16	ADD
	Micromemoria[5]= 0x00048001;	//SC 6,9,24				PULA PARA 18	SUBTRACT
	Micromemoria[6]= 0x00050011;	//SC 6,8,20,24			PULA PARA 20	MULTIPLY
	Micromemoria[7]= 0x00094001;	//SC 5,8,10,24			PULA PARA 37	DIVIDE
	Micromemoria[8]= 0x000d8001;	//SC 5,6,8,9,24			PULA PARA 54	JUMP
	Micromemoria[9]= 0x000dc001;	//SC 5,6,8,9,10,24		PULA PARA 55	JUMPZERO
	Micromemoria[10]=0x000e8001;	//SC 5,6,7,9,24			PULA PARA 58	JUMPNEG
	Micromemoria[11]=0x00000001;	//STOP
	Micromemoria[12]=0x00040322;	//SC 6,15,16,19,23		LOAD
	Micromemoria[13]=0x00022000;	//SC 7,11				LOAD
	Micromemoria[14]=0x00040222;	//SC 6,15,19,23			STORE
	Micromemoria[15]=0x00400480;	//SC 2,14,17			STORE
	Micromemoria[16]=0x00040322;	//SC 6,15,16,19,23		ADD
	Micromemoria[17]=0x00422000;	//SC 2,7,11,			ADD
	Micromemoria[18]=0x00040322;	//SC 6,15,16,19,23		SUBTRACT
	Micromemoria[19]=0x00432000;	//SC 2,7,8,11			SUBTRACT
	Micromemoria[54]=0x00044000;	//SC 6,10				JUMP
	Micromemoria[55]=0x00000012;	//SC 20,23				JUMPZERO
	Micromemoria[56]=0x00044000;	//SC 6,10				JUMPZERO
	Micromemoria[57]=0x00000000;	//SC					JUMPZERO
	Micromemoria[58]=0x0000000a;	//SC 21,23				JUMPNEG
	Micromemoria[59]=0x00044000;	//SC 6,10				JUMPNEG
	Micromemoria[60]=0x00000000;	//SC					JUMPNEG
}

void converte_micromemoria_unsigned_long_int(int indice,char buffer1[26]){
     unsigned long int valor=0;
     int b;
     
     for(b=23;b>=0;b--){
         if (buffer1[b]=='1'){
              valor+=pot2((23-b));
         }     
     }     
     Micromemoria[indice]=valor;
}

void insere_micromemoria_usuario(){
       char *nomep,nome[10];
       FILE *arq=NULL;  // ponteiro para arquivo

       while (arq == NULL){
             printf("\nDigite o nome do arquivo da micromemoria e ENTER.\n\n");
             scanf("%s",&nome);
             nomep=(char*)malloc(sizeof(nome));
             nomep=nome;
             
             arq = fopen(nomep, "r");
             
             if (arq  == NULL) {
                printf("Erro ao ler arquivo.\n\n");
             }
             else{
                    char buffer[26];
                    int n=0; 
                    while( fgets(buffer,sizeof(buffer),arq) != NULL ){
                         converte_micromemoria_unsigned_long_int(n,buffer);  // Micromemoria[n]=buffer 
                         n++;
					}
					fclose(arq);
					getchar();
             }
       }
       printf("Micromemoria lida.");       
}

void abre_arq_saida(){
       char *nomep,nome[10];
	   while (arq_saida == NULL){
             printf("\nDigite o nome do arquivo de saida da simulacao e ENTER.\n\n");
             scanf("%s",&nome);
             nomep=(char*)malloc(sizeof(nome));
             nomep=nome;
             
             arq_saida = fopen(nomep, "w");
	   }
       
       printf("\n\nInicio da Simulacao.\n");
       getchar();
       getchar();
}

void interface_entrada(){
     // PARTE 1: insere a micromemria
     char entrada='1';
     
     while (entrada != 'S' && entrada != 's' && entrada != 'N' && entrada != 'n'){
         printf("Voce deseja usar a micromemoria padrao? (S/N)");
         scanf("%c",&entrada);
         getchar();					//espera enter
     }
     
     if (entrada == 'S' || entrada == 's'){
            insere_micromemoria_default();
     }
	 else{
            insere_micromemoria_usuario();
     } 
     
     // PARTE 2: insere a memria principal

	 insere_programa_usuario();
	 
	 // PARTE 3: recebe nome do arquivo de saida
	 
	 abre_arq_saida();
}    

void zera_variaveis(){
    
    int i;
    
    MIR=0;                    
    MPC=0;
    BI1=0;
    BI2=0;
    BI3=0;       
    PC=0;
    Acc=0;
    R1=0;
    R2=0;
    B1=0;
    B2=0;
    B3=0;
    RDM=0;
    REM=0;
    RI=0;
    for(i=0;i<4000;i++)
            Mem_principal[i]=0;          
    for(i=0;i<1000;i++)
            Micromemoria[i]=0;       
}

void exibe_variaveis(){
    printf("\n\n");					  fprintf(arq_saida,"\n\n");
    printf("\n\n");                   fprintf(arq_saida,"\n\n");
    printf(" Acc=%d\n",Acc);          fprintf(arq_saida," Acc=%d\n",Acc);
    printf(" MPC=%d\n",MPC);          fprintf(arq_saida," MPC=%d\n",MPC);
    printf(" R1=%d\n",R1);            fprintf(arq_saida," R1=%d\n",R1);
    printf(" R2=%d\n",R2);            fprintf(arq_saida," R2=%d\n",R2);
    printf(" PC=%d\n",PC);            fprintf(arq_saida," PC=%d\n",PC);
    printf(" RDM=$%x\n",(RDM&0xFFFF));fprintf(arq_saida," RDM=$%x\n",(RDM&0xFFFF));
    printf(" REM=%d\n",REM);          fprintf(arq_saida," REM=%d\n",REM);
    printf(" RI=$%x\n",RI);           fprintf(arq_saida," RI=$%x\n",RI);
    printf(" B1=%d\n",B1);            fprintf(arq_saida," B1=%d\n",B1);
    printf(" B2=%d\n",B2);            fprintf(arq_saida," B2=%d\n",B2);
    printf(" B3=%d\n",B3);            fprintf(arq_saida," B3=%d\n",B3);
    printf(" BI1=%d\n",BI1);          fprintf(arq_saida," BI1=%d\n",BI1);
    printf(" BI2=%d\n",BI2);          fprintf(arq_saida," BI2=%d\n",BI2);
    printf(" BI3=%d\n",BI3);          fprintf(arq_saida," BI3=%d\n",BI3);
    printf("\n");                     fprintf(arq_saida,"\n");
}

void exibe_inicio(){
    printf("************************************************************************\n"); 
    printf("*   Simulador do Processador Microprogramado EA869                     *\n");
    printf("*           Autor: Felipe Sineiro Herig.                               *\n");
	printf("*    Atualizado por Rodrigo Muraro em 01/2008.                         *\n");
    printf("************************************************************************\n\n\n");
}

void visualizar_memoria(){
    int i, inicio=0, fim=1;
    char entrada='1';
    
    printf("\n\n"); 
    while (entrada != 'S' && entrada != 's' && entrada != 'N' && entrada != 'n'){
         printf("\nVoce deseja visualizar a memoria principal? (S/N)");
         scanf("%c",&entrada);
         getchar();					//espera enter
    }

    if(entrada == 'S' || entrada == 's'){
         while(inicio!=fim) {
                printf("digite o endereco INICIAL (em decimal).\n"); 
                scanf("%d",&inicio);
                printf("digite o endereco FINAL (em decimal).\n"); 
                scanf("%d",&fim);
                if(inicio!=fim && (fim-inicio)<50 ){
                      for(i=inicio;i<=fim;i++)
                           printf("Mem_principal[%d]=%d\n",i,converte_sinal(Mem_principal[i]));     
                }
                printf("\npara encerrar digite endereco inicial e final ZERO.\n\n"); 
         }
    }
}

/***********************************************************************
*                                                                      * 
*                           ROTINA PRINCIPAL                           * 
*                                                                      *
************************************************************************/
int main(){
    
	exibe_inicio();
    
    zera_variaveis();
	
    interface_entrada();   //recebe entrada e gera mem_principal e micromemoria
	
	inicia_MPC_MIR();
	
	fprintf(arq_saida,"Simulacao:\n");
	
	while(!STOP){    /*loop se repete ate o comando STOP*/
	    
        exibe_variaveis();
        
        /*fases do PROCESSADOR*/
		fase1();
        fase2();
        fase3();
        /*Fases do CONTROLADOR*/
		fase4();
        fase5();
    
		getchar();    
        
    }		     /* loop programa principal */
    
    printf("\n");
	fprintf(arq_saida,"\n");
    exibe_variaveis();
    printf("\n\n Final da Simulacao.\n");
	fprintf(arq_saida,"\n\n Final da Simulacao.\n");
    
    fclose(arq_saida);
    
    
    visualizar_memoria();
    
	getchar();
    return(0);
}

